

CREATE TABLE DEPT (
  DEPTNO  INTEGER  NOT NULL,
  NAME  VARCHAR(30)  NOT NULL  UNIQUE,
  LOCATION  VARCHAR(50),
  BUDGET  NUMERIC  DEFAULT 0,

  CONSTRAINT PK_DEPTNO  PRIMARY KEY (DEPTNO)
);

CREATE TABLE EMP (
  EMPNO  INTEGER  NOT NULL,
  NAME  VARCHAR(30)  NOT NULL,
  MANAGER  INTEGER  NOT NULL,
  PLZ  CHAR(5),
  CITY  VARCHAR(50),
  DEPTNO  INTEGER  NOT NULL,

  CONSTRAINT PK_EMPNO  PRIMARY KEY (EMPNO)
);

CREATE TABLE HAS_HOBBY (
  EMPNO  INTEGER  NOT NULL,
  HNR  INTEGER  NOT NULL,

  CONSTRAINT PK_HOBBY_EMPNO  PRIMARY KEY (EMPNO)
);

CREATE TABLE HOBBY (
  HNR  INTEGER  NOT NULL,
  NAME  VARCHAR(30)  NOT NULL,

  CONSTRAINT PK_HNR  PRIMARY KEY (HNR)
);

/*
  Tabelle ist ein Weak-Entity
*/
CREATE TABLE KID (
  NAME  VARCHAR(30)  NOT NULL,
  EMPNO  INTEGER  NOT NULL,

  CONSTRAINT PK_NAME PRIMARY KEY (NAME, EMPNO )
);



ALTER TABLE EMP ADD CONSTRAINT 
   FK_DEPT_EMP FOREIGN KEY (DEPTNO) REFERENCES DEPT(DEPTNO);


ALTER TABLE EMP ADD CONSTRAINT 
   FK_EMP_EMP FOREIGN KEY (MANAGER) REFERENCES EMP(EMPNO);


ALTER TABLE HAS_HOBBY ADD CONSTRAINT 
   FK_EMP_HAS_HOBBY FOREIGN KEY (EMPNO) REFERENCES EMP(EMPNO);


ALTER TABLE KID ADD CONSTRAINT 
   FK_EMP_KID FOREIGN KEY (EMPNO) REFERENCES EMP(EMPNO);


ALTER TABLE HAS_HOBBY ADD CONSTRAINT 
   FK_HOBBY_HAS_HOBBY FOREIGN KEY (HNR) REFERENCES HOBBY(HNR);




ALTER TABLE DEPT
     ADD CONSTRAINT CH_BUDGET CHECK (
  BUDGET >=0
);


CREATE SEQUENCE SEQ;
